//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4884A05B0190.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4884A05B0190.cm

//## begin module%4884A05B0190.cp preserve=no
//## end module%4884A05B0190.cp

//## Module: IncGamma%4884A05B0190; Package specification
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/IncGamma.h

#ifndef INCGAMMA_H
#define INCGAMMA_H 1

//## begin module%4884A05B0190.additionalIncludes preserve=no
//## end module%4884A05B0190.additionalIncludes

//## begin module%4884A05B0190.includes preserve=yes
#include <xsTypes.h>
//## end module%4884A05B0190.includes

//## begin module%4884A05B0190.declarations preserve=no
//## end module%4884A05B0190.declarations

//## begin module%4884A05B0190.additionalDeclarations preserve=yes
//## end module%4884A05B0190.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    //## begin Numerics::IncGamma%4884A6190022.preface preserve=yes
    //## end Numerics::IncGamma%4884A6190022.preface

    //## Class: IncGamma%4884A6190022
    //	The IncGamma class computes the unnormalized incomplete
    //	Gamma function:
    //
    //	                 [inf]
    //	  Gamma(a,x) = Int   exp^(-t)*t^(a-1)dt
    //	                 [x]
    //	                   = Gamma(a)*Q(a,x)
    //
    //	with the restriction that x > 0.0.  If x <= 0.0, the
    //	operator() function will throw a YellowAlert.  'a' is
    //	allowed to be pos, zero, or neg.
    //## Category: XSUtil::Numerics%3F6F5A7603D4
    //## Subsystem: XSUtil::Numerics%41E6D0F3003C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class IncGamma 
    {
      //## begin Numerics::IncGamma%4884A6190022.initialDeclarations preserve=yes
      //## end Numerics::IncGamma%4884A6190022.initialDeclarations

      public:
        //## Constructors (generated)
          IncGamma();


        //## Other Operations (specified)
          //## Operation: operator()%4884A67402AF
          Real operator () (const Real a, const Real x) const;

        // Additional Public Declarations
          //## begin Numerics::IncGamma%4884A6190022.public preserve=yes
          //## end Numerics::IncGamma%4884A6190022.public

      protected:
        // Additional Protected Declarations
          //## begin Numerics::IncGamma%4884A6190022.protected preserve=yes
          //## end Numerics::IncGamma%4884A6190022.protected

      private:

        //## Other Operations (specified)
          //## Operation: continuousFraction%4884A845012A
          static Real continuousFraction (const Real a, const Real x);

          //## Operation: seriesSolution%4884A86E03D2
          static Real seriesSolution (const Real a, const Real x);

          //## Operation: integrateByParts%4884A8C2006C
          //	This is needed for small 'x' and negative 'a'.
          static Real integrateByParts (const Real a, const Real x);

        // Additional Private Declarations
          //## begin Numerics::IncGamma%4884A6190022.private preserve=yes
          //## end Numerics::IncGamma%4884A6190022.private

      private: //## implementation
        // Additional Implementation Declarations
          //## begin Numerics::IncGamma%4884A6190022.implementation preserve=yes
          //## end Numerics::IncGamma%4884A6190022.implementation

    };

    //## begin Numerics::IncGamma%4884A6190022.postscript preserve=yes
    //## end Numerics::IncGamma%4884A6190022.postscript

    // Class Numerics::IncGamma 

} // namespace Numerics

//## begin module%4884A05B0190.epilog preserve=yes
//## end module%4884A05B0190.epilog


#endif
